New-PSUEndpoint -Url "/hyperv/vm" -Description "Gets the VMs on this Hyper-V host. " -Endpoint {
Get-VM | Select-Object Name, @{n = 'State'; e={$_.State.ToString()}},MemoryAssigned,CPUUsage
} -ErrorAction "Stop" -Timeout 0 
New-PSUEndpoint -Url "/hyperv/host" -Description "Gets information about this Hyper-V host." -Endpoint {
Get-VMHost | Select-Object ComputerName, LogicalProcessorCount, MemoryCapacity
} -Timeout 0 
New-PSUEndpoint -Url "/hyperv/switch" -Description "Gets the switches on this VM host. " -Endpoint {
Get-VMSwitch | Select-Object Name, @{n="SwitchType";e={$_.SwitchType.ToString()}}, NetAdapterInterfaceDescription
} -Timeout 0 
New-PSUEndpoint -Url "/hyperv/vm/:name" -Description "Start a VM. " -Method "POST" -Endpoint {
param($Name)

Start-VM -Name $Name
} -Timeout 0 
New-PSUEndpoint -Url "/hyperv/vm/:name" -Description "Stop a VM. " -Method "DELETE" -Endpoint {
param($Name)

Stop-VM -Name $Name
} -Timeout 0 
New-PSUEndpoint -Url "/hypver/vm/:name/checkpoint/:checkpoint" -Description "Take a snapshot of a VM" -Method "POST" -Endpoint {
param($name, $checkpoint)

Checkpoint-VM -Name $Name -SnapshotName $checkpoint
} -Timeout 0 
New-PSUEndpoint -Url "/hyperv/vm/:name/checkpoint" -Description "Get the checkpoints for a VM. " -Endpoint {
param($name)

Get-VMCheckpoint -VMName $Name
} -Timeout 0 
New-PSUEndpoint -Url "/hyperv/vm/:name/checkpoint/:checkpoint" -Description "Delete a VM checkpoint. " -Method "DELETE" -Endpoint {
param($name, $checkpoint)

Remove-VMCheckpoint -Name $Name -Checkpoint $Checkpoint
} -Timeout 0